/*
   void getkey();    // wait for keypress.
   void checkkey();  // no wait.
   extern unsigned char    key, scan;
   -- by Benny, '97.

   TC/WC/GC.
   v1.5
   non-'if (!key) key = scan;' version
*/
#include <bios.h>

#ifndef _KEYCODES_H
#include "KEYCODES.H"
#endif

extern unsigned char       key, scan, shift;
void  getkey();
void  checkkey();

#ifndef _GETKEY_H
#define _GETKEY_H

unsigned char   key=0, scan=0, shift=0;
#ifdef __TURBOC__
static char *rombios = (char*)0x00400017;
#else
static char *rombios = (char*)0x417;
#endif

#define RIGHTSHIFT	(*rombios&1)
#define LEFTSHIFT	(*rombios&2)
void  getkey()
{
	unsigned short thekey;

	while (!_bios_keybrd(_KEYBRD_READY));
	thekey = _bios_keybrd(_KEYBRD_READ);
	key = thekey&0xFF;  scan = (thekey>>8)&0xFF;
#if 0
	if (!key) key = scan;
#endif
	if (RIGHTSHIFT || LEFTSHIFT)	    shift = 1;
	else                        	    shift = 0;
}

void  checkkey()
{
	unsigned short thekey;

	key = scan = 0;
	if (!_bios_keybrd(_KEYBRD_READY)) return;
	thekey = _bios_keybrd(_KEYBRD_READ);
	key = thekey&0xFF;  scan = (thekey>>8)&0xFF;
#if 0
	if (!key) key = scan;
#endif
	if (RIGHTSHIFT || LEFTSHIFT)	    shift = 1;
	else                        	    shift = 0;
}

#endif // _GETKEY_H
